## ubuntu-advantage-tools 32.3.1~16.04

=== debian/changelog ===
ubuntu-advantage-tools (32.3.1~16.04) xenial; urgency=medium

  * Adjust the esm_cache apparmor profile to allow reading of dpkg data
    directory (LP: #2067810):
    - d/apparmor/ubuntu_pro_esm_cache.jinja2: allow /var/lib/dpkg/** for dpkg
      and other profiles
    - features/steps/machines.py: trigger the bug in the behave test suite,
      which tests the fix
  * version.py: update version to 32.3.1

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 07 Jun 2024 14:52:55 -0300

ubuntu-advantage-tools (32.3~16.04) xenial; urgency=medium

  * Backport 32.3 to xenial (LP: #2060732)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 28 May 2024 15:15:32 -0300

ubuntu-advantage-tools (32.3) oracular; urgency=medium

  * d/apparmor: adjust the profiles to account for usr-merge consequences
    (LP: #2067319)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 28 May 2024 14:43:12 -0300

ubuntu-advantage-tools (32.2) oracular; urgency=medium

  * d/apparmor: adjust rules for violations found during testing (LP: #2066929)

 -- Grant Orndorff <grant.orndorff@canonical.com>  Thu, 23 May 2024 10:47:11 -0500

ubuntu-advantage-tools (32.1) oracular; urgency=medium

  * d/apparmor: allow access for /etc/os-release on all supported
    profiles (LP: #2065573)
  * apport: get path for timer job status from the correct place (LP: #2065616)

 -- Lucas Moura <lucas.moura@canonical.com>  Tue, 14 May 2024 11:22:35 +0200

ubuntu-advantage-tools (32) oracular; urgency=medium

  * d/postinst: ensure migrations happen in correct package postinst (GH: #2982)
  * d/apparmor: introduce new ubuntu_pro_esm_cache apparmor policy
  * New upstream release 32 (LP: #2060732)
    - api:
      + u.pro.attach.token.full_token_attach.v1: add support for attach
        with token
      + u.pro.services.disable.v1: add support for disable operation
      + u.pro.services.enable.v1: add support for enable operation
      + u.pro.detach.v1: add support for detach operation
      + u.pro.status.is_attached.v1: add extra fields to API response
      + u.pro.services.dependencies.v1: add support for service dependencies
      + u.pro.security.fix.*.plan.v1: update ESM cache during plan API
        if needed
    - apt_news: add architectures and packages selectors filters for apt news
    - cli:
      + improved cli/log message for unexpected errors (GH: #2600)
      + properly handle setting empty config values (GH: #2925)
    - cloud-init: support ubuntu_pro user-data
    - collect-logs: update default output file to pro_logs.tar.gz (LP: #2033313)
    - config: create public and private config (GH: #2809)
    - entitlements:
      + update logic that checks if a service is enabled (LP: #2031192)
    - fips: warn/confirm with user if enabling fips downgrades the kernel
    - fix: warn users if ESM cache cannot be updated (GH: #2841)
    - logging:
      + use journald logging for all systemd services
      + add redundancy to secret redaction
    - messaging:
      + add consistent messaging for end of contract state
      + make explicit that unattached enable/disable is a noop (GH: #2487)
      + make explicit that disabling a disabled service is a noop
      + make explicit that enabling an enabled service is a noop
    - notices: filter unreadable notices when listing notices (GH: #2898)

 -- Lucas Moura <lucas.moura@canonical.com>  Tue, 09 Apr 2024 17:33:36 -0300

## ubuntu-advantage-tools 32.3.1~18.04

=== debian/changelog ===
ubuntu-advantage-tools (32.3.1~18.04) bionic; urgency=medium

  * Adjust the esm_cache apparmor profile to allow reading of dpkg data
    directory (LP: #2067810):
    - d/apparmor/ubuntu_pro_esm_cache.jinja2: allow /var/lib/dpkg/** for dpkg
      and other profiles
    - features/steps/machines.py: trigger the bug in the behave test suite,
      which tests the fix
  * version.py: update version to 32.3.1

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 07 Jun 2024 14:52:55 -0300

ubuntu-advantage-tools (32.3~18.04) bionic; urgency=medium

  * Backport 32.3 to bionic (LP: #2060732)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 28 May 2024 15:15:36 -0300

## ubuntu-advantage-tools 32.3.1~20.04

=== debian/changelog ===
ubuntu-advantage-tools (32.3.1~20.04) focal; urgency=medium

  * Adjust the esm_cache apparmor profile to allow reading of dpkg data
    directory (LP: #2067810):
    - d/apparmor/ubuntu_pro_esm_cache.jinja2: allow /var/lib/dpkg/** for dpkg
      and other profiles
    - features/steps/machines.py: trigger the bug in the behave test suite,
      which tests the fix
  * version.py: update version to 32.3.1

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 07 Jun 2024 14:52:55 -0300

ubuntu-advantage-tools (32.3~20.04) focal; urgency=medium

  * Backport 32.3 to focal (LP: #2060732)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 28 May 2024 15:15:39 -0300

## ubuntu-advantage-tools 32.3.1~22.04

=== debian/changelog ===
ubuntu-advantage-tools (32.3.1~22.04) jammy; urgency=medium

  * Adjust the esm_cache apparmor profile to allow reading of dpkg data
    directory (LP: #2067810):
    - d/apparmor/ubuntu_pro_esm_cache.jinja2: allow /var/lib/dpkg/** for dpkg
      and other profiles
    - features/steps/machines.py: trigger the bug in the behave test suite,
      which tests the fix
  * version.py: update version to 32.3.1

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 07 Jun 2024 14:52:55 -0300

ubuntu-advantage-tools (32.3~22.04) jammy; urgency=medium

  * Backport 32.3 to jammy (LP: #2060732)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 28 May 2024 15:15:42 -0300

## ubuntu-advantage-tools 32.3.1~23.10

=== debian/changelog ===
ubuntu-advantage-tools (32.3.1~23.10) mantic; urgency=medium

  * Adjust the esm_cache apparmor profile to allow reading of dpkg data
    directory (LP: #2067810):
    - d/apparmor/ubuntu_pro_esm_cache.jinja2: allow /var/lib/dpkg/** for dpkg
      and other profiles
    - features/steps/machines.py: trigger the bug in the behave test suite,
      which tests the fix
  * version.py: update version to 32.3.1

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 07 Jun 2024 14:52:55 -0300

ubuntu-advantage-tools (32.3~23.10) mantic; urgency=medium

  * Backport 32.3 to mantic (LP: #2060732)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 28 May 2024 15:15:45 -0300

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

include /etc/os-release

# see https://bugs.launchpad.net/ubuntu/+source/ubuntu-advantage-tools/+bug/1840091/comments/3

# Bionic and Xenial each have older versions of distro-info that don't support
# the flag --supported-esm. Those versions are 0.18 and 0.14build1,
# respectively. So we set specific distro-info requirements for bionic and later
# versus Xenial to make those contraints applicable on each series.
DISTRO_INFO_DEPS=distro-info (>= 0.18ubuntu0.18.04.1),

ifeq (${VERSION_ID},"16.04")
APT_PKG_DEPS=apt (>= 1.2.32), apt-transport-https (>= 1.2.32), apt-utils (>= 1.2.32), libapt-inst2.0 (>= 1.2.32), libapt-pkg5.0 (>= 1.2.32),
DISTRO_INFO_DEPS=distro-info (>= 0.14ubuntu0.2),
else ifeq (${VERSION_ID},"18.04")
APT_PKG_DEPS=apt (>= 1.6.11), apt-utils (>= 1.6.11), libapt-inst2.0 (>= 1.6.11), libapt-pkg5.0 (>= 1.6.11),
endif

%:
	dh $@ --with python3,bash-completion,systemd --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	make -C apt-hook build
	make -C debian/po build

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# Hooks will only be delivered on LTS instances
ifeq (LTS,$(findstring LTS,$(VERSION)))
	make -C apt-hook test
endif
	python3 -m pytest
	python3 -m flake8 uaclient
endif

override_dh_gencontrol:
	echo "extra:Depends=$(APT_PKG_DEPS) $(DISTRO_INFO_DEPS)" >> debian/ubuntu-pro-client.substvars
	dh_gencontrol

override_dh_systemd_enable:
	dh_systemd_enable -pubuntu-pro-auto-attach ua-auto-attach.service
	dh_systemd_enable -pubuntu-pro-client ua-reboot-cmds.service
	dh_systemd_enable -pubuntu-pro-client ua-timer.timer
	dh_systemd_enable -pubuntu-pro-client ua-timer.service
	dh_systemd_enable -pubuntu-pro-client ubuntu-advantage.service
ifeq (${VERSION_ID},"16.04")
	# Only enable cloud-id-shim on Xenial
	dh_systemd_enable -pubuntu-pro-client ubuntu-advantage-cloud-id-shim.service
endif

override_dh_systemd_start:
	dh_systemd_start -pubuntu-pro-client ua-timer.timer
	dh_systemd_start -pubuntu-pro-client ubuntu-advantage.service

override_dh_auto_install:
	dh_auto_install --destdir=debian/ubuntu-pro-client
	debian/jinja2_render debian/apparmor/ubuntu_pro_apt_news.jinja2 debian/apparmor/ubuntu_pro_apt_news ubuntu_codename=${UBUNTU_CODENAME}
	debian/jinja2_render debian/apparmor/ubuntu_pro_esm_cache.jinja2 debian/apparmor/ubuntu_pro_esm_cache ubuntu_codename=${UBUNTU_CODENAME}
	# quick syntax check on the generated profiles
	mkdir debian/apparmor/local
	touch debian/apparmor/local/ubuntu_pro_apt_news
	touch debian/apparmor/local/ubuntu_pro_esm_cache
	apparmor_parser -I $(CURDIR)/debian/apparmor -K -T -Q debian/apparmor/ubuntu_pro_apt_news
	apparmor_parser -I $(CURDIR)/debian/apparmor -K -T -Q debian/apparmor/ubuntu_pro_esm_cache
	install -D -m 644 $(CURDIR)/debian/apparmor/ubuntu_pro_apt_news $(CURDIR)/debian/ubuntu-pro-client/etc/apparmor.d/ubuntu_pro_apt_news
	install -D -m 644 $(CURDIR)/debian/apparmor/ubuntu_pro_esm_cache $(CURDIR)/debian/ubuntu-pro-client/etc/apparmor.d/ubuntu_pro_esm_cache
	dh_apparmor -pubuntu-pro-client --profile-name=ubuntu_pro_apt_news
	dh_apparmor -pubuntu-pro-client --profile-name=ubuntu_pro_esm_cache

	flist=$$(find $(CURDIR)/debian/ -type f -name version.py) && sed -i 's,@@PACKAGED_VERSION@@,$(DEB_VERSION),' $${flist:-did-not-find-version-py-for-replacement}

	# We install the conf file even on non-LTS version to avoid issues on upgrade scenarios
	make -C apt-hook DESTDIR=$(CURDIR)/debian/ubuntu-pro-client install-conf
	make -C apt-hook DESTDIR=$(CURDIR)/debian/ubuntu-pro-client install

	# We want to guarantee that we are not shipping any conftest files
	find $(CURDIR)/debian/ubuntu-pro-client -type f -name conftest.py -delete

ifneq (${VERSION_ID},"16.04")
	# Only install cloud-id-shim on Xenial
	rm $(CURDIR)/debian/ubuntu-pro-client/lib/systemd/system/ubuntu-advantage-cloud-id-shim.service
endif

	# Move ua-auto-attach.service out to ubuntu-pro-auto-attach
	mkdir -p debian/ubuntu-pro-auto-attach/lib/systemd/system
	mv debian/ubuntu-pro-client/lib/systemd/system/ua-auto-attach.* debian/ubuntu-pro-auto-attach/lib/systemd/system

	# move migration scripts from before the package rename into ubuntu-advantage-tools
	mkdir -p debian/ubuntu-advantage-tools/usr/lib/ubuntu-advantage
	mv debian/ubuntu-pro-client/usr/lib/ubuntu-advantage/migrate_user_config.py debian/ubuntu-advantage-tools/usr/lib/ubuntu-advantage
	mv debian/ubuntu-pro-client/usr/lib/ubuntu-advantage/patch_status_json.py debian/ubuntu-advantage-tools/usr/lib/ubuntu-advantage


override_dh_auto_clean:
	dh_auto_clean
	make clean

## ubuntu-advantage-tools 32.3.1~24.04

=== debian/changelog ===
ubuntu-advantage-tools (32.3.1~24.04) noble; urgency=medium

  * Adjust the esm_cache apparmor profile to allow reading of dpkg data
    directory (LP: #2067810):
    - d/apparmor/ubuntu_pro_esm_cache.jinja2: allow /var/lib/dpkg/** for dpkg
      and other profiles
    - features/steps/machines.py: trigger the bug in the behave test suite,
      which tests the fix
  * version.py: update version to 32.3.1

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 07 Jun 2024 14:52:55 -0300

ubuntu-advantage-tools (32.3~24.04) noble; urgency=medium

  * Backport 32.3 to noble (LP: #2060732)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 28 May 2024 15:15:48 -0300

## ubuntu-advantage-tools 33~16.04

=== debian/changelog ===
ubuntu-advantage-tools (33~16.04) xenial; urgency=medium

  * Backport 33 to xenial (LP: #2069237)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 04 Jul 2024 09:45:51 -0300

ubuntu-advantage-tools (33) oracular; urgency=medium

  * d/apparmor: adjust the esm_cache apparmor profile to allow reading of dpkg
    data directory (LP: #2067810) (GH: #3137)
  * New upstream release 33 (LP: #2069237)
    - apt: use Python bindings instead of apt CLI to query for installed
      packages (LP: #2060769) (LP: #2068744)
    - beta: drop support for beta services
    - contracts: add support for contracts which target a specific series
    - fips: change enable functionality to ensure all packages with a FIPS
      candidate are upgraded to the FIPS version (GH: #2667)
    - fix: 
      + add the current_status field to the plan api return object
      + change recommended attach method to magic attach (GH: #3040)
    - livepatch: prefer the term 'coverage' instead of 'support' in messaging
      (GH: #3063)
    - realtime:
      + auto-select the raspi variant when appropriate
      + inform the user when auto-selecting a variant

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 13 Jun 2024 00:19:54 -0300

## ubuntu-advantage-tools 33~18.04

=== debian/changelog ===
ubuntu-advantage-tools (33~18.04) bionic; urgency=medium

  * Backport 33 to bionic (LP: #2069237)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 04 Jul 2024 09:46:00 -0300

## ubuntu-advantage-tools 33~20.04

=== debian/changelog ===
ubuntu-advantage-tools (33~20.04) focal; urgency=medium

  * Backport 33 to focal (LP: #2069237)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 04 Jul 2024 09:46:09 -0300

## ubuntu-advantage-tools 33~22.04

=== debian/changelog ===
ubuntu-advantage-tools (33~22.04) jammy; urgency=medium

  * Backport 33 to jammy (LP: #2069237)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 04 Jul 2024 09:46:18 -0300

## ubuntu-advantage-tools 33~24.04

=== debian/changelog ===
ubuntu-advantage-tools (33~24.04) noble; urgency=medium

  * Backport 33 to noble (LP: #2069237)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 04 Jul 2024 09:46:26 -0300

## ubuntu-advantage-tools 34~16.04

=== debian/changelog ===
ubuntu-advantage-tools (34~16.04) xenial; urgency=medium

  * Backport 34 to xenial (LP: #2075543)

 -- Grant Orndorff <grant.orndorff@canonical.com>  Fri, 06 Sep 2024 19:58:18 -0400

ubuntu-advantage-tools (34) oracular; urgency=medium

  * d/rules: check that version.py is consistent with changelog (GH: #3154)
  * New upstream release 34: (LP: #2075543)
    - apt-hook: redirect errors away from users (LP: #2074211, LP: #2055239)
    - detach: ensure apt bearer tokens are always cleaned up
    - fips-preview: add warnings and prompts similar to fips and fips-updates
    - fips and realtime-kernel: add warning when the new kernel may have
      different hardware support than the current kernel based on the flavor
      (GH: #3115)
    - fix: use more reliable api query param when looking up CVE fixes
    - help:
      + change help output for base pro command
      + remove service descriptions from output (GH: #3126)
      + show help content when run without a subcommand
    - timer: recover from corrupted job status file (LP: #2078737)
    - update manpage

 -- Grant Orndorff <grant.orndorff@canonical.com>  Mon, 29 Jul 2024 15:48:22 -0500

ubuntu-advantage-tools (33.2) oracular; urgency=medium

  * d/apparmor: add apt-news access to package information on the system
    (LP: #2072489) (GH: #3193)

 -- Lucas Moura <lucas.moura@canonical.com>  Wed, 17 Jul 2024 09:50:56 -0300

ubuntu-advantage-tools (33.1) oracular; urgency=medium

  * New upstream release 33.1: (LP: #2060769)
    - system:
      + always pass C.UTF8 as the language when calling a subprocess
      + ignore utf-8 decode errors on subprocess output

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 10 Jul 2024 16:43:02 -0300

## ubuntu-advantage-tools 34~18.04

=== apt-hook/Makefile ===
all: build

build: json-hook

json-hook: json-hook.cc
	$(CXX) -Wall -Wextra -Wshadow -pedantic -std=c++11 $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -g -o json-hook json-hook-main.cc json-hook.cc esm-counts.cc -ljson-c -lapt-pkg $(LDLIBS)

test:
	$(CXX) -Wall -Wextra -Wshadow -pedantic -std=c++11 $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -g -o json-hook-test json-hook.cc json-hook.test.cc esm-counts.cc -ljson-c -lapt-pkg -lboost_unit_test_framework $(LDLIBS)
	./json-hook-test

install-conf:
	install -D -m 644 20apt-esm-hook.conf $(DESTDIR)/etc/apt/apt.conf.d/20apt-esm-hook.conf

install: json-hook
	install -D -m 755 json-hook $(DESTDIR)/usr/lib/ubuntu-advantage/apt-esm-json-hook

clean:
	rm -f json-hook json-hook-test

.PHONY: test

=== debian/changelog ===
ubuntu-advantage-tools (34~18.04) bionic; urgency=medium

  * Backport 34 to bionic (LP: #2075543)

 -- Grant Orndorff <grant.orndorff@canonical.com>  Fri, 06 Sep 2024 19:58:19 -0400

=== debian/control ===
Source: ubuntu-advantage-tools
Section: misc
Priority: important
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: bash-completion,
               debhelper (>=9),
               debianutils (>= 4.7),
               dh-python,
               dh-apparmor,
               apparmor,
# After debhelper 13.3 we no longer need dh-systemd.
# On hirsute and later, dh-systemd doesn't even exist.
# On recent releases, the first alternative will be used.
# On older releases (where debhelper is older than 13.3 and we need dh-systemd), the second alternative is used.
# Putting debhelper first allows a successful build on recent releases without requiring --resolve-alternatives during sbuild.
               debhelper (>= 13.3) | dh-systemd,
               gettext,
               git,
               libapt-pkg-dev,
               python3-apt,
               libjson-c-dev,
               libboost-test-dev,
               po-debconf,
               python3 (>= 3.4),
               python3-flake8,
               python3-jinja2,
               python3-mock,
               python3-pytest,
               python3-setuptools,
               python3-yaml
Standards-Version: 4.5.1
Homepage: https://ubuntu.com/advantage
Vcs-Git: https://github.com/canonical/ubuntu-pro-client.git
Vcs-Browser: https://github.com/canonical/ubuntu-pro-client
Rules-Requires-Root: no

Package: ubuntu-advantage-tools
Depends: ubuntu-pro-client (>= ${binary:Version}), ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional dummy package for ubuntu-pro-client
 This is a transitional dummy package for ubuntu-pro-client. It can safely be
 removed.

Package: ubuntu-pro-client
Homepage: https://canonical-ubuntu-pro-client.readthedocs-hosted.com/
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         python3-apt,
         python3-pkg-resources,
         ${extra:Depends}
Recommends: ubuntu-pro-client-l10n
Breaks: ubuntu-advantage-tools (<<31~), ${misc:Breaks}
Replaces: ubuntu-advantage-tools (<<31~)
# IMPORTANT: ubuntu-pro-client does not "Provide" ubuntu-advantage-tools
# At the time of the rename, existing releases with ubuntu-advantage-tools
# include xenial, bionic, focal, jammy, and mantic.
# We cannot allow ubuntu-advantage-tools <<31 to be removed on those releases,
# because it could break ESM (remove sources.list entries in prerm).
# On those releases, ubuntu-minimal (and ubuntu-cloud-minimal) Depends on
# ubuntu-advantage-tools, which prevents it from being removed without also
# removing ubuntu-minimal or ubuntu-cloud-minimal. We consider that to be a
# sufficient warning to users that removing ubuntu-advantage-tools is not
# supported.
# If ubuntu-pro-client were to "Provide" ubuntu-advantage-tools, then that
# mechanism would not work, and users could remove ubuntu-advantage-tools
# accidentally.
# ubuntu-pro-client could "Provide" ubuntu-advantage-tools in releases in the
# future, but it would not add any value over having the ubuntu-advantage-tools
# transitional dummy package.
Description: Management tools for Ubuntu Pro
 Ubuntu Pro is a suite of additional services provided by Canonical on
 top of Ubuntu. Whether you're an enterprise customer deploying systems
 at scale or want security patching for your personal Ubuntu LTS
 at home, the Ubuntu Pro Client (pro) is the command-line tool that
 will help you manage the services you need.

Package: ubuntu-pro-client-l10n
Architecture: any
Depends: ${misc:Depends}, ubuntu-pro-client (= ${binary:Version})
Description: Translations for Ubuntu Pro Client
 This package delivers translations of Ubuntu Pro Client for various
 languages.

Package: ubuntu-advantage-pro
Depends: ubuntu-pro-auto-attach, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional dummy package for ubuntu-pro-auto-attach
 This is a transitional dummy package for ubuntu-pro-auto-attach. It can
 safely be removed.

Package: ubuntu-pro-auto-attach
Homepage: https://canonical-ubuntu-pro-client.readthedocs-hosted.com/en/latest/explanations/what_are_ubuntu_pro_cloud_instances/
Architecture: all
Depends: ${misc:Depends}, ubuntu-pro-client (>=31~)
Breaks: ubuntu-advantage-pro (<<31~)
Replaces: ubuntu-advantage-pro (<<31~)
Provides: ubuntu-advantage-pro
Description: Service to auto-attach Ubuntu Pro cloud images
 This package delivers an additional service that performs an auto-attach
 operation for Ubuntu Pro cloud instances. This package should not be manually
 installed, as it is already present on the cloud instances that require it.

## ubuntu-advantage-tools 34~20.04

=== debian/changelog ===
ubuntu-advantage-tools (34~20.04) focal; urgency=medium

  * Backport 34 to focal (LP: #2075543)

 -- Grant Orndorff <grant.orndorff@canonical.com>  Fri, 06 Sep 2024 19:58:21 -0400

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 include /etc/os-release
 
 # see https://bugs.launchpad.net/ubuntu/+source/ubuntu-advantage-tools/+bug/1840091/comments/3
+
+MISC_BREAKS=""
 
 # Bionic and Xenial each have older versions of distro-info that don't support
 # the flag --supported-esm. Those versions are 0.18 and 0.14build1,
@@ -18,12 +20,20 @@
 DISTRO_INFO_DEPS=distro-info (>= 0.14ubuntu0.2),
 else ifeq (${VERSION_ID},"18.04")
 APT_PKG_DEPS=apt (>= 1.6.11), apt-utils (>= 1.6.11), libapt-inst2.0 (>= 1.6.11), libapt-pkg5.0 (>= 1.6.11),
+else ifeq (${VERSION_ID},"24.04")
+# Noble python3-minimal has a bug that can break upgrades on systems with non-utf-translations
+# https://bugs.launchpad.net/ubuntu/+source/python3-defaults/+bug/2075337
+MISC_BREAKS=python3-minimal (<< 3.12.3-0ubuntu2~)
 endif
 
 %:
 	dh $@ --with python3,bash-completion,systemd --buildsystem=pybuild
 
 override_dh_auto_build:
+	# fail early if version.py wasn't updated to match d/changelog's version
+	# only take into account the actual upstream version, discarding ubuntu and
+	# backport suffixes
+	python3 tools/check-versions-are-consistent.py
 	dh_auto_build
 	make -C apt-hook build
 	make -C debian/po build
@@ -40,6 +50,7 @@
 
 override_dh_gencontrol:
 	echo "extra:Depends=$(APT_PKG_DEPS) $(DISTRO_INFO_DEPS)" >> debian/ubuntu-pro-client.substvars
+	echo "misc:Breaks=$(MISC_BREAKS)" >> debian/ubuntu-pro-client.substvars
 	dh_gencontrol
 
 override_dh_systemd_enable:

## ubuntu-advantage-tools 34~22.04

=== debian/changelog ===
ubuntu-advantage-tools (34~22.04) jammy; urgency=medium

  * Backport 34 to jammy (LP: #2075543)

 -- Grant Orndorff <grant.orndorff@canonical.com>  Fri, 06 Sep 2024 19:58:22 -0400

## ubuntu-advantage-tools 34~24.04

=== debian/changelog ===
ubuntu-advantage-tools (34~24.04) noble; urgency=medium

  * Backport 34 to noble (LP: #2075543)

 -- Grant Orndorff <grant.orndorff@canonical.com>  Fri, 06 Sep 2024 19:58:23 -0400

## ubuntu-advantage-tools 34.1.2

=== debian/changelog ===
ubuntu-advantage-tools (34.1.2) oracular; urgency=medium

  * check-versions-are-consistent.py: fix regexp to cope with X.Y.Z version
    formats
  * version.py: bump to 34.1.2

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 04 Oct 2024 17:06:07 -0300

ubuntu-advantage-tools (34.1.1) oracular; urgency=medium

  * Bump version.py.

 -- Robie Basak <robie.basak@ubuntu.com>  Fri, 04 Oct 2024 20:34:56 +0100

ubuntu-advantage-tools (34.1) oracular; urgency=medium

  * Drop direct dependency on python3-pkg-resources to resolve priority
    mismatch (LP: #2083665)

 -- Robie Basak <robie.basak@ubuntu.com>  Fri, 04 Oct 2024 17:51:47 +0100

## ubuntu-advantage-tools 35

=== debian/changelog ===
ubuntu-advantage-tools (35) plucky; urgency=medium

  * d/tests/usage: add more scenarios to dep8 tests
  * d/control: drop strict dependency on python3-pkg-resources (LP: #2083665)
  * d/rules: add conditional python3-pkg-resources dependency up to noble
  * d/ubuntu-pro-client.postrm: remove /var/lib/ubuntu-pro cache dir on purge
  * New upstream release 35: (LP: #2083973)
    - api:
      + new endpoints:
        * u.pro.attach.guest.get_guest_token.v1: Get the Pro client guest
          token
        * u.pro.security.cves.v1: List the fixable CVEs that affect the system
      + u.pro.packages.updates.v1: create new package status:
        upgrade_available_not_preferred (GH: #3184)
      + fixes for u.unattended_upgrades.status.v1:
        * do not crash when a Unattended-Upgrade config is missing
        * do not report unattended-upgrade disabled if any config is false
        * report missing Unattended-Upgrade configs as turned off
    - apt:
      + always ensure the ESM cache is present (GH: #3132)
      + fix permission warning when fetching apt-news (GH: #3209, LP: #2070095)
      + update logging for apt errors (GH: #3299)
      + only run the apt upgrade hook when run as root (LP: #2084677)
    - auto-attach:
      + aws: skip operation if no product codes found
      + gcp: add minimal image license codes
    - cli:
      + add support for vulnerability commands:
        * pro cves: List cves in the machine
        * pro cve: Show information about a specific cve
      + deduplicate entries in 'pro help' output (LP: #2091327)
    - config: add option lxd_guest_attach to control LXD integration with Pro
    - contract:
      + check onlySeries on reboot (GH: #3189)
      + collect cpu type for activity info
    - landscape:
      + update message if service not available through Pro (GH: #3331)
    - livepatch: do not enable livepatch on wsl (GH: #3156)
    - lxd: allow pro auto-attach to work on a LXD container

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 20 Feb 2025 12:00:14 -0300

ubuntu-advantage-tools (34.1.3) plucky; urgency=medium

  * apt-hook: set C++ standards version to c++17 for APT 2.9.30 compatibility
    (LP: #2098862)
  * tests: remove argparse error tests from unit tests (LP: #2098862)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 19 Feb 2025 11:53:40 -0300

ubuntu-advantage-tools (34.1.2build1) plucky; urgency=high

  * No change rebuild against libapt-pkg7.0.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 17 Feb 2025 22:47:04 +0100

## ubuntu-advantage-tools 35.1ubuntu0~16.04

=== debian/changelog ===
ubuntu-advantage-tools (35.1ubuntu0~16.04) xenial; urgency=medium

  * Backport 35.1ubuntu0 to xenial (LP: #2106660)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 10 Apr 2025 10:38:31 -0300

ubuntu-advantage-tools (35.1ubuntu0) plucky; urgency=medium

  * apt: support ESM snapshots by adding snapshot URLs for ESM repositories
    to the authentication file (released in version 35)
  * lxd: store the configuration in /var/lib/ubuntu-advantage instead of
    /var/lib/ubuntu-pro (LP: #2106660)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 09 Apr 2025 13:19:50 -0300

## ubuntu-advantage-tools 35.1ubuntu0~18.04

=== debian/changelog ===
ubuntu-advantage-tools (35.1ubuntu0~18.04) bionic; urgency=medium

  * Backport 35.1ubuntu0 to bionic (LP: #2106660)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Thu, 10 Apr 2025 10:38:34 -0300

## ubuntu-advantage-tools 36ubuntu0~16.04

=== debian/changelog ===
ubuntu-advantage-tools (36ubuntu0~16.04) xenial; urgency=medium

  * Backport 36ubuntu0 to xenial (LP: #2112382)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 24 Jun 2025 09:20:00 -0300

ubuntu-advantage-tools (36ubuntu0) questing; urgency=medium

  * d/apparmor/ubuntu_pro_esm_cache.jinja2: use openssl abstraction in the
    apparmor profile
  * New upstream release 36: (LP: #2112382)
    - api: display all available valid CVEs
    - attach: relax the onlySeries directive, so users can attach onlySeries
      tokens to all releases older than the target release
    - cli:
      + anbox-cloud: update installation instructions
      + collect-logs: do not overwrite the output file if it exists
      + cve/cves:
        * return all affected packages for a cve (LP: #2111610)
        * handle the case where the vulnerability data doesn't exist for the
          Ubuntu release
    - fips:
      + enable --access-only for all fips related services (GH: #3441)
      + allow enablement even when the -updates pocket is not available in the
        system (GH: #3439)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Fri, 06 Jun 2025 11:08:26 -0300

## ubuntu-advantage-tools 36ubuntu0~18.04

=== debian/changelog ===
ubuntu-advantage-tools (36ubuntu0~18.04) bionic; urgency=medium

  * Backport 36ubuntu0 to bionic (LP: #2112382)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 24 Jun 2025 09:20:05 -0300

## ubuntu-advantage-tools 36ubuntu0~20.04

=== debian/changelog ===
ubuntu-advantage-tools (36ubuntu0~20.04) focal; urgency=medium

  * Backport 36ubuntu0 to focal (LP: #2112382)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 24 Jun 2025 09:20:07 -0300

## ubuntu-advantage-tools 36ubuntu0~22.04

=== debian/changelog ===
ubuntu-advantage-tools (36ubuntu0~22.04) jammy; urgency=medium

  * Backport 36ubuntu0 to jammy (LP: #2112382)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 24 Jun 2025 09:20:09 -0300

## ubuntu-advantage-tools 36ubuntu0~24.04

=== debian/changelog ===
ubuntu-advantage-tools (36ubuntu0~24.04) noble; urgency=medium

  * Backport 36ubuntu0 to noble (LP: #2112382)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 24 Jun 2025 09:20:12 -0300

## ubuntu-advantage-tools 36ubuntu0~24.10

=== debian/changelog ===
ubuntu-advantage-tools (36ubuntu0~24.10) oracular; urgency=medium

  * Backport 36ubuntu0 to oracular (LP: #2112382)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 24 Jun 2025 09:20:14 -0300

## ubuntu-advantage-tools 36ubuntu0~25.04

=== debian/changelog ===
ubuntu-advantage-tools (36ubuntu0~25.04) plucky; urgency=medium

  * Backport 36ubuntu0 to plucky (LP: #2112382)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Tue, 24 Jun 2025 09:20:16 -0300

## ubuntu-advantage-tools 37ubuntu0~16.04

=== debian/changelog ===
ubuntu-advantage-tools (37ubuntu0~16.04) xenial; urgency=medium

  * Backport 37ubuntu0 to xenial (LP: #2125453)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 01 Oct 2025 15:35:52 -0300

ubuntu-advantage-tools (37ubuntu0) questing; urgency=medium

  * d/apparmor/ubuntu_pro_[apt_news|esm_cache].jinja2: update coreutils path
    Thanks to Georgia Garcia <georgia.garcia@canonical.com> (LP: #2123870)
  * New upstream release 37: (LP: #2125453)
    - attach: don't show a notice if attaching a one-time token set for a
      future release (GH: #3485)
    - enable: add the --auto option to enable all default services based on
      the contract
    - entitlements:
      + add esm-infra-legacy support
      + add esm-apps-legacy support
    - fips: show correct kernel versions when downgrading on clouds (GH: #3488)
    - upgrade-lts-contract: (LP: #2107604)
      + remove implicit dependency on lsof
      + fix the logic to hold the apt lock while performing operations

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Mon, 22 Sep 2025 21:51:46 -0300

## ubuntu-advantage-tools 37ubuntu0~18.04

=== debian/changelog ===
ubuntu-advantage-tools (37ubuntu0~18.04) bionic; urgency=medium

  * Backport 37ubuntu0 to bionic (LP: #2125453)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 01 Oct 2025 15:35:54 -0300

## ubuntu-advantage-tools 37ubuntu0~20.04

=== debian/changelog ===
ubuntu-advantage-tools (37ubuntu0~20.04) focal; urgency=medium

  * Backport 37ubuntu0 to focal (LP: #2125453)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 01 Oct 2025 15:35:57 -0300

## ubuntu-advantage-tools 37ubuntu0~22.04

=== debian/changelog ===
ubuntu-advantage-tools (37ubuntu0~22.04) jammy; urgency=medium

  * Backport 37ubuntu0 to jammy (LP: #2125453)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 01 Oct 2025 15:35:59 -0300

## ubuntu-advantage-tools 37ubuntu0~24.04

=== debian/changelog ===
ubuntu-advantage-tools (37ubuntu0~24.04) noble; urgency=medium

  * Backport 37ubuntu0 to noble (LP: #2125453)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 01 Oct 2025 15:36:02 -0300

## ubuntu-advantage-tools 37ubuntu0~25.04

=== debian/changelog ===
ubuntu-advantage-tools (37ubuntu0~25.04) plucky; urgency=medium

  * Backport 37ubuntu0 to plucky (LP: #2125453)

 -- Renan Rodrigo <renanrodrigo@canonical.com>  Wed, 01 Oct 2025 15:36:04 -0300

## ubuntu-advantage-tools 37ubuntu0

=== debian/po/Makefile ===
all: build

POS=$(wildcard *.po)
MOS=$(POS:.po=.mo)

%.mo: %.po
	mkdir -p usr/share/locale/$*/LC_MESSAGES
	msgfmt --check-format $< -o usr/share/locale/$*/LC_MESSAGES/ubuntu-pro.mo

build: $(MOS)

=== debian/rules ===
--- 
+++ 
@@ -15,15 +15,27 @@
 # versus Xenial to make those contraints applicable on each series.
 DISTRO_INFO_DEPS=distro-info (>= 0.18ubuntu0.18.04.1),
 
+# The python3-pkg-resources dependency is no longer needed after Oracular.
+# Because of that, we will only add it to the packages created for older
+# Ubuntu releases
+PYTHON3_PKG_RESOURCES=""
+
 ifeq (${VERSION_ID},"16.04")
 APT_PKG_DEPS=apt (>= 1.2.32), apt-transport-https (>= 1.2.32), apt-utils (>= 1.2.32), libapt-inst2.0 (>= 1.2.32), libapt-pkg5.0 (>= 1.2.32),
 DISTRO_INFO_DEPS=distro-info (>= 0.14ubuntu0.2),
+PYTHON3_PKG_RESOURCES=python3-pkg-resources
 else ifeq (${VERSION_ID},"18.04")
 APT_PKG_DEPS=apt (>= 1.6.11), apt-utils (>= 1.6.11), libapt-inst2.0 (>= 1.6.11), libapt-pkg5.0 (>= 1.6.11),
+PYTHON3_PKG_RESOURCES=python3-pkg-resources
+else ifeq (${VERSION_ID},"20.04")
+PYTHON3_PKG_RESOURCES=python3-pkg-resources
+else ifeq (${VERSION_ID},"22.04")
+PYTHON3_PKG_RESOURCES=python3-pkg-resources
 else ifeq (${VERSION_ID},"24.04")
 # Noble python3-minimal has a bug that can break upgrades on systems with non-utf-translations
 # https://bugs.launchpad.net/ubuntu/+source/python3-defaults/+bug/2075337
 MISC_BREAKS=python3-minimal (<< 3.12.3-0ubuntu2~)
+PYTHON3_PKG_RESOURCES=python3-pkg-resources
 endif
 
 %:
@@ -49,7 +61,7 @@
 endif
 
 override_dh_gencontrol:
-	echo "extra:Depends=$(APT_PKG_DEPS) $(DISTRO_INFO_DEPS)" >> debian/ubuntu-pro-client.substvars
+	echo "extra:Depends=$(APT_PKG_DEPS) $(DISTRO_INFO_DEPS) $(PYTHON3_PKG_RESOURCES)" >> debian/ubuntu-pro-client.substvars
 	echo "misc:Breaks=$(MISC_BREAKS)" >> debian/ubuntu-pro-client.substvars
 	dh_gencontrol

=== debian/tests/control ===
Tests: usage
Restrictions: allow-stderr, superficial

## ubuntu-advantage-tools 37.1ubuntu0~16.04

=== debian/changelog ===
ubuntu-advantage-tools (37.1ubuntu0~16.04) xenial; urgency=medium

  * Backport 37.1ubuntu0 to xenial (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Mon, 27 Oct 2025 09:41:59 -0300

ubuntu-advantage-tools (37.1ubuntu0) resolute; urgency=medium

  * do-release-upgrade: immediately release the APT lock acquired to run the
    post-upgrade hook (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Thu, 23 Oct 2025 16:30:36 -0300

## ubuntu-advantage-tools 37.1ubuntu0~18.04

=== debian/changelog ===
ubuntu-advantage-tools (37.1ubuntu0~18.04) bionic; urgency=medium

  * Backport 37.1ubuntu0 to bionic (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Mon, 27 Oct 2025 09:42:07 -0300

## ubuntu-advantage-tools 37.1ubuntu0~20.04

=== debian/changelog ===
ubuntu-advantage-tools (37.1ubuntu0~20.04) focal; urgency=medium

  * Backport 37.1ubuntu0 to focal (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Mon, 27 Oct 2025 09:42:09 -0300

## ubuntu-advantage-tools 37.1ubuntu0~22.04

=== debian/changelog ===
ubuntu-advantage-tools (37.1ubuntu0~22.04) jammy; urgency=medium

  * Backport 37.1ubuntu0 to jammy (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Mon, 27 Oct 2025 09:42:11 -0300

## ubuntu-advantage-tools 37.1ubuntu0~24.04

=== debian/changelog ===
ubuntu-advantage-tools (37.1ubuntu0~24.04) noble; urgency=medium

  * Backport 37.1ubuntu0 to noble (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Mon, 27 Oct 2025 09:42:14 -0300

## ubuntu-advantage-tools 37.1ubuntu0~25.04

=== debian/changelog ===
ubuntu-advantage-tools (37.1ubuntu0~25.04) plucky; urgency=medium

  * Backport 37.1ubuntu0 to plucky (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Mon, 27 Oct 2025 09:42:17 -0300

## ubuntu-advantage-tools 37.1ubuntu0~25.10

=== debian/changelog ===
ubuntu-advantage-tools (37.1ubuntu0~25.10) questing; urgency=medium

  * Backport 37.1ubuntu0 to questing (LP: #2129712)

 -- Renan Rodrigo <rr@ubuntu.com>  Mon, 27 Oct 2025 09:42:19 -0300

## ubuntu-advantage-tools 37.1ubuntu0

=== Makefile ===
mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
mkfile_dir := $(dir $(mkfile_path))

build:
	$(MAKE) -C apt-hook build

clean:
	rm -f *.build *.buildinfo *.changes .coverage *.deb *.dsc *.tar.gz *.tar.xz
	rm -f azure-*-uaclient-ci-* ec2-uaclient-ci-* gcp-*-uaclient-ci-* lxd-container-*-uaclient-ci-* lxd-virtual-machine-*-uaclient-ci-*
	rm -rf *.egg-info/ .tox/ .cache/ .mypy_cache/
	rm -rf docs/build/
	find . -type f -name '*.pyc' -delete
	find . -type d -name '*__pycache__' -delete
	$(MAKE) -C apt-hook clean

deps:
	@which mk-build-deps > /dev/null || { \
		echo "Missing mk-build-deps; installing devscripts, equivs."; \
		apt-get install --no-install-recommends --yes devscripts equivs; \
	}
	mk-build-deps --tool "apt-get --no-install-recommends --yes" \
		--install --remove ${mkfile_dir}/debian/control

test:
	@tox

.PHONY: build clean test

=== apt-hook/Makefile ===
all: build

build: json-hook

json-hook: json-hook.cc
	$(CXX) -Wall -Wextra -Wshadow -pedantic -std=c++17 $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -g -o json-hook json-hook-main.cc json-hook.cc esm-counts.cc -ljson-c -lapt-pkg $(LDLIBS)

test:
	$(CXX) -Wall -Wextra -Wshadow -pedantic -std=c++17 $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -g -o json-hook-test json-hook.cc json-hook.test.cc esm-counts.cc -ljson-c -lapt-pkg -lboost_unit_test_framework $(LDLIBS)
	./json-hook-test

install-conf:
	install -D -m 644 20apt-esm-hook.conf $(DESTDIR)/etc/apt/apt.conf.d/20apt-esm-hook.conf

install: json-hook
	install -D -m 755 json-hook $(DESTDIR)/usr/lib/ubuntu-advantage/apt-esm-json-hook

clean:
	rm -f json-hook json-hook-test

.PHONY: test

=== debian/control ===
--- 
+++ 
@@ -50,7 +50,6 @@
          ${python3:Depends},
          ${shlibs:Depends},
          python3-apt,
-         python3-pkg-resources,
          ${extra:Depends}
 Recommends: ubuntu-pro-client-l10n
 Breaks: ubuntu-advantage-tools (<<31~), ${misc:Breaks}
